SystemOrganization addCategory: #'Xtreams-Substreams'!

!BlockClosure methodsFor: '*Xtreams-Substreams-private' stamp: 'MartinKobetic 12/31/2010 00:36'!
streamingReadMatching: aStream inclusive: tail
	^XTTestReadSubstream on: aStream test: self inclusive: tail! !

!BlockClosure methodsFor: '*Xtreams-Substreams-private' stamp: 'MartinKobetic 12/31/2010 00:36'!
streamingWriteMatching: aStream inclusive: tail
	^XTTestWriteSubstream on: aStream test: self inclusive: tail! !

!Object methodsFor: '*Xtreams-Substreams-private' stamp: 'nice 10/10/2010 18:34'!
streamingReadMatching: aStream inclusive: tail
	^[:each | each == self] streamingReadMatching: aStream inclusive: tail! !

!Object methodsFor: '*Xtreams-Substreams-private' stamp: 'nice 10/10/2010 18:34'!
streamingWriteMatching: aStream inclusive: tail
	^[:each | each == self] streamingWriteMatching: aStream inclusive: tail! !

XTWriteStream subclass: #XTStitchWriteStream
	instanceVariableNames: 'active contentsSpecies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-Substreams'!

!XTStitchWriteStream commentStamp: '<historical>' prior: 0!
StitchWriteStream combines a stream of source which returns streams in to a single continuous stream.

Instance Variables
	active	<WriteStream>	the substream that is currently active
	contentsSpecies	<Class>	the contents species of the substreams

!

!XTStitchWriteStream class methodsFor: 'instance creation' stamp: 'nice 7/8/2011 23:11'!
on: aDestination contentsSpecies: aClass
	^self new on: aDestination contentsSpecies: aClass! !

!XTStitchWriteStream class methodsFor: 'instance creation' stamp: 'MartinKobetic 1/1/2011 16:41'!
on: aDestination first: firstActiveStream
	^self new on: aDestination first: firstActiveStream! !

!XTStitchWriteStream methodsFor: 'initialize-release' stamp: 'MartinKobetic 1/1/2011 12:09'!
close
	self flush.
	destination close! !

!XTStitchWriteStream methodsFor: 'initialize-release' stamp: 'MartinKobetic 1/1/2011 12:09'!
contentsSpecies
	^contentsSpecies! !

!XTStitchWriteStream methodsFor: 'initialize-release' stamp: 'MartinKobetic 1/1/2011 12:09'!
flush
	active == nil ifTrue: [^self].
	active close.
	active := nil! !

!XTStitchWriteStream methodsFor: 'initialize-release' stamp: 'nice 7/8/2011 23:12'!
on: aDestination contentsSpecies: aClass
	super on: aDestination.
	contentsSpecies := aClass! !

!XTStitchWriteStream methodsFor: 'initialize-release' stamp: 'MartinKobetic 1/1/2011 12:09'!
on: aDestination first: firstActiveStream
	super on: aDestination.
	active := firstActiveStream.
	contentsSpecies := active contentsSpecies! !

!XTStitchWriteStream methodsFor: 'accessing' stamp: 'MartinKobetic 1/11/2011 17:53'!
write: anInteger from: aSequenceableCollection at: startIndex
	| remaining amount index |
	index := startIndex.
	remaining := anInteger.
	amount := 0.
	[
		active == nil ifTrue: [
			[active := destination get]
				on: Incomplete
				do: [ :ex | (Incomplete on: aSequenceableCollection count: anInteger - remaining at: startIndex) raise]].
		amount := [active write: remaining from: aSequenceableCollection at: index] on: Incomplete do: [:ex | ex count].
		remaining := remaining - amount.
		index := index + amount.
		remaining > 0] whileTrue:
			[active close.
			active := nil].
	^anInteger! !

!XTWriteStream methodsFor: '*Xtreams-Substreams-substreaming' stamp: 'MartinKobetic 12/31/2010 02:00'!
closing: aBlock
	^(XTPositionWriteSubstream on: self)
		closeBlock: aBlock;
		yourself! !

!XTWriteStream methodsFor: '*Xtreams-Substreams-substreaming' stamp: 'MartinKobetic 1/1/2011 16:47'!
ending: aMatchable
	"Creates a substream that will end when aMatchable finds a match in the content passing through. aMatchable is either
		* a block that is evaluated with each element - the stream ends when the block returns true
		* a collection that is matched against the last elements written - the stream ends when the collection matches
		* any other object - the stream ends when an equal object is written into the stream"
	"	aMatchable	<BlockClosure | Collection | Object> the substream ending criteria
		^<TransformWriteStream>
	""	
		| stream slice |
		stream := String new writing.
		slice := stream ending: $j.
		[ slice write: 'abcdefghijklmnopqrstuvxyz' ] on: Incomplete do: [].
		stream conclusion
	""
		| stream slice |
		stream := String new writing.
		slice := stream ending: 'mno'.
		[ slice write: 'abcdefghijklmnopqrstuvxyz' ] on: Incomplete do: [].
		stream conclusion
	""
		| stream slice |
		stream := String new writing.
		slice := stream ending: [ :e | 'gmt' includes: e ].
		[ slice write: 'abcdefghijklmnopqrstuvxyz' ] on: Incomplete do: [].
		stream conclusion
	"
	^self ending: aMatchable inclusive: false! !

!XTWriteStream methodsFor: '*Xtreams-Substreams-substreaming' stamp: 'MartinKobetic 1/1/2011 16:48'!
ending: aMatchable inclusive: inclusive
	"Creates a substream that will end when aMatchable finds a match in the content passing through. aMatchable is either
		* a block that is evaluated with each element - the stream ends when the block returns true
		* a collection that is matched against the last elements written - the stream ends when the collection matches
		* any other object - the stream ends when an equal object is written into the stream"
	"	aMatchable	<BlockClosure | Collection | Object> the substream ending criteria
		inclusive <Boolean> should the matched elements be included in the stream contents or not
		^<TransformWriteStream>
	""
		| stream slice |
		stream := String new writing.
		slice := stream ending: $j inclusive: true.
		[ slice write: 'abcdefghijklmnopqrstuvxyz' ] on: Incomplete do: [].
		stream conclusion
	""
		| stream slice |
		stream := String new writing.
		slice := stream ending: 'mno' inclusive: true.
		[ slice write: 'abcdefghijklmnopqrstuvxyz' ] on: Incomplete do: [].
		stream conclusion
	""
		| stream slice |
		stream := String new writing.
		slice := stream ending: [ :e | 'gmt' includes: e ] inclusive: true.
		[ slice write: 'abcdefghijklmnopqrstuvxyz' ] on: Incomplete do: [].
		stream conclusion
	"
	^aMatchable streamingWriteMatching: self inclusive: inclusive! !

!XTWriteStream methodsFor: '*Xtreams-Substreams-substreaming' stamp: 'MartinKobetic 1/1/2011 16:48'!
limiting: limit
	"Create a substream that will allow at most @limit number of elements written into the destination."
	"	limit	<Integer>	maximum number of elements that can be written into destination
		^<LimitWriteStream>"
	"
		| stream slice |
		stream := String new writing.
		slice := stream limiting: 5.
		[ slice write: 'abcdefghi' ] on: Incomplete do: [].
		stream conclusion
	"

	^XTLimitWriteSubstream on: self limit: limit! !

!XTWriteStream methodsFor: '*Xtreams-Substreams-substreaming' stamp: 'MartinKobetic 1/11/2011 17:53'!
slicing
	"From a writable stream, return a readable stream that acts as a prototype factory for the writable stream."
	"	^<ReadStream>"
	"(destination limiting: 10) slicing"

	| substream |
	substream := nil.
	^[substream == nil ifFalse:
		[substream substreamClosed ifFalse: [substream close].
		substream subseekend.
		substream destinationAtEnd ifTrue: [Incomplete zero raise]].
		substream := self copy]
		reading
			closeBlock: [destination close];
			yourself! !

!XTWriteStream methodsFor: '*Xtreams-Substreams-substreaming' stamp: 'MartinKobetic 1/1/2011 12:17'!
stitching
	^self error: 'You can only stitch a read stream, however that read stream can return write streams and in so doing, you will create a stitching write stream.'! !

XTWriteStream subclass: #XTWriteSubstream
	instanceVariableNames: 'destinationAtEnd closeBlock substreamClosed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-Substreams'!

!XTWriteSubstream commentStamp: '<historical>' prior: 0!
This is abstract superclass of all substreams. Substreams normally don't close their underlying source, their closing behavior is customized via closeBlock.

Instance Variables
	destinationAtEnd	<Boolean> flags end of the destination
	closeBlock	<BlockClosure> unary block invoked in response to #close, allows customizing closing behavior
	substreamClosed	<Boolean> flags the end of the receiver

!

XTWriteSubstream subclass: #XTMatchWriteSubstream
	instanceVariableNames: 'substreamAtEnd pattern patternStart inclusive backtrack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-Substreams'!

!XTMatchWriteSubstream commentStamp: '<historical>' prior: 0!
This is a substream bounded by a string pattern. The algorithm used doesn't need to peek or step back to detect the pattern, so it can be used on non-positionable streams.

Instance Variables
	substreamAtEnd	<Boolean> is this substream at end
	pattern	<String> the bounding pattern
	patternStart	<Integer> 
	inclusive	<Boolean> is the boundary part of the substream contents
	backtrack	<Array> backtracking table for pattern

!

!XTMatchWriteSubstream class methodsFor: 'instance creation' stamp: 'nice 10/10/2010 18:02'!
on: aDestination pattern: aPattern backtrack: aBacktrack inclusive: aBoolean
	^self new on: aDestination pattern: aPattern backtrack: aBacktrack inclusive: aBoolean! !

!XTMatchWriteSubstream methodsFor: 'private' stamp: 'nice 10/10/2010 18:23'!
gobble: anObject
	| patternStop match |
	patternStop := patternStart.
	(match := anObject = (pattern at: patternStop)) ifTrue: [patternStop := patternStop + 1].

	"A full pattern match"
	patternStop > pattern size ifTrue: [
		inclusive ifTrue: [destination write: pattern size from: pattern at: 1].
		substreamAtEnd := true.
		^self].

	"Partial match, in progress"
	match ifTrue: [patternStart := patternStop. ^self].

	"No match at all, write out the object we just read"
	patternStart = 1 ifTrue: [
		destination put: anObject.
		patternStart := 1.
		^self].

	"Partial match was in progress, but anObject didn't match, so write out the part of the pattern and try anObject again from the backtrack position"
	destination write: patternStart - 1 from: pattern at: 1.
	patternStart := backtrack at: patternStop.
	self gobble: anObject! !

!XTMatchWriteSubstream methodsFor: 'accessing' stamp: 'nice 7/8/2011 23:19'!
insert: anInteger from: aSequenceableCollection at: startIndex
	^self write: anInteger from: aSequenceableCollection at: startIndex! !

!XTMatchWriteSubstream methodsFor: 'initialize-release' stamp: 'nice 10/10/2010 18:23'!
on: aDestination pattern: aPattern backtrack: aBacktrack inclusive: aBoolean
	self on: aDestination.
	pattern := aPattern.
	backtrack := aBacktrack.
	patternStart := 1.
	inclusive := aBoolean.
	substreamAtEnd := false! !

!XTMatchWriteSubstream methodsFor: 'accessing' stamp: 'MartinKobetic 1/11/2011 17:53'!
put: anObject
	substreamAtEnd ifTrue: [Incomplete zero raise].
	[self gobble: anObject] on: Incomplete do: [:incomplete | destinationAtEnd := substreamAtEnd := true. incomplete pass].
	^anObject! !

!XTMatchWriteSubstream methodsFor: 'private' stamp: 'nice 10/10/2010 18:23'!
streamingInsert: anInteger from: aReadStream
	self streamingWrite: anInteger from: aReadStream! !

!XTMatchWriteSubstream methodsFor: 'private' stamp: 'nice 10/10/2010 18:23'!
streamingInsertFrom: aReadStream
	self streamingWriteFrom: aReadStream! !

!XTMatchWriteSubstream methodsFor: 'private' stamp: 'MartinKobetic 1/11/2011 17:53'!
streamingWrite: anInteger from: aReadStream
	| count |
	count := 0.
	[[count < anInteger and: [substreamAtEnd not]] whileTrue:
		[self gobble: aReadStream get.
		count := count + 1]]
			on: Incomplete do: [:incomplete |
				destinationAtEnd := substreamAtEnd := true.
				(Incomplete count: count) raise].
	count < anInteger ifTrue:
		[substreamAtEnd := true.
		(Incomplete count: count) raise].
	^anInteger! !

!XTMatchWriteSubstream methodsFor: 'private' stamp: 'MartinKobetic 1/11/2011 17:53'!
streamingWriteFrom: aReadStream
	| count |
	substreamAtEnd ifTrue: [Incomplete zero raise].
	count := 0.
	^[[substreamAtEnd not] whileTrue: [self gobble: aReadStream get. count := count + 1]]
		on: Incomplete do: [:incomplete | destinationAtEnd := substreamAtEnd := true. count ]! !

!XTMatchWriteSubstream methodsFor: 'accessing' stamp: 'MartinKobetic 1/11/2011 17:53'!
write: anInteger from: aSequenceableCollection at: startIndex
	| count |
	count := 0.
	[[count < anInteger and: [substreamAtEnd not]] whileTrue:
		[self gobble: (aSequenceableCollection at: startIndex + count).
		count := count + 1]]
			on: Incomplete do: [:incomplete |
				destinationAtEnd := substreamAtEnd := true.
				(Incomplete on: aSequenceableCollection count: count at: startIndex) raise].
	count < anInteger ifTrue:
		[substreamAtEnd := true.
		(Incomplete on: aSequenceableCollection count: count at: startIndex) raise].
	^anInteger! !

XTWriteSubstream subclass: #XTPositionWriteSubstream
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-Substreams'!

!XTPositionWriteSubstream commentStamp: '<historical>' prior: 0!
This is an abstract substreams that keeps track of its own position and allows positioning if the underlying stream is positionable.

Instance Variables
	position	<Integer> current position within the substream

!

XTPositionWriteSubstream subclass: #XTLimitWriteSubstream
	instanceVariableNames: 'limit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-Substreams'!

!XTLimitWriteSubstream commentStamp: 'nice 10/10/2010 20:33' prior: 0!
Limits the number of elements that can be written into the destination stream.

Instance Variables
	limit	<Integer> maximum number of elements that can be written into this stream
	position	<Integer> number of elements already written into the stream

!

!XTLimitWriteSubstream class methodsFor: 'instance creation' stamp: 'nice 10/10/2010 18:02'!
on: aDestination limit: anInteger
	^self new on: aDestination limit: anInteger! !

!XTLimitWriteSubstream methodsFor: 'seeking' stamp: 'MartinKobetic 1/11/2011 17:53'!
-= anInteger
	| available |
	anInteger < 0 ifTrue: [Incomplete zero raise].
	available := anInteger min: limit.
	destination ++ (limit - position - available).
	position := limit - available.
	available = anInteger ifTrue: [^anInteger].
	^(Incomplete count: available) raise! !

!XTLimitWriteSubstream methodsFor: 'accessing' stamp: 'nice 7/8/2011 23:17'!
insert: anInteger from: aSequenceableCollection at: startIndex
	| count |
	count := anInteger min: self available.
	super insert: count from: aSequenceableCollection at: startIndex.
	count < anInteger ifTrue: [(Incomplete on: aSequenceableCollection count: count at: startIndex) raise].
	^anInteger! !

!XTLimitWriteSubstream methodsFor: 'seeking' stamp: 'nice 10/10/2010 18:18'!
length
	^limit! !

!XTLimitWriteSubstream methodsFor: 'initialize-release' stamp: 'nice 10/10/2010 18:18'!
on: aDestination limit: anInteger
	self on: aDestination.
	limit := anInteger! !

!XTLimitWriteSubstream methodsFor: 'accessing' stamp: 'MartinKobetic 1/11/2011 17:53'!
put: anObject
	position = limit ifTrue: [Incomplete zero raise].
	^super put: anObject! !

!XTLimitWriteSubstream methodsFor: 'initialize-release' stamp: 'nice 10/10/2010 18:18'!
subseekend
	self isPositionable ifFalse: [^self].
	self -= 0! !

!XTLimitWriteSubstream methodsFor: 'accessing' stamp: 'MartinKobetic 1/11/2011 17:53'!
write: anInteger from: aSequenceableCollection at: startIndex
	| count |
	count := anInteger min: self available.
	super write: count from: aSequenceableCollection at: startIndex.
	count < anInteger ifTrue: [(Incomplete on: aSequenceableCollection count: count at: startIndex) raise].
	^anInteger! !

!XTPositionWriteSubstream methodsFor: 'seeking' stamp: 'MartinKobetic 1/11/2011 17:53'!
++ anInteger
	| count |
	anInteger < 0 ifTrue: [ ^self -- anInteger negated ].
	count := self available min: anInteger.
	count := [destination ++ count. count] on: Incomplete do: [ :ex | ex count ].
	position := position + count.
	count < anInteger ifTrue: [destinationAtEnd := true. (Incomplete count: count) raise].
	^anInteger! !

!XTPositionWriteSubstream methodsFor: 'seeking' stamp: 'MartinKobetic 1/11/2011 17:53'!
-- anInteger
	| count |
	anInteger < 0 ifTrue: [ ^self ++ anInteger negated ].
	count := anInteger min: position.
	count := [destination -- count. count] on: Incomplete do: [ :ex | ex count ].
	position := position - count.
	count < anInteger ifTrue: [(Incomplete count: count) raise].
	anInteger isZero ifFalse: [destinationAtEnd := false].
	^anInteger! !

!XTPositionWriteSubstream methodsFor: 'seeking' stamp: 'MartinKobetic 1/1/2011 12:20'!
-= anInteger
	position := self length - anInteger max: 0.
	^destination -= anInteger.! !

!XTPositionWriteSubstream methodsFor: 'accessing' stamp: 'nice 7/8/2011 23:18'!
insert: anInteger from: aSequenceableCollection at: startIndex
	[destination insert: anInteger from: aSequenceableCollection at: startIndex] on: Incomplete do: [:incomplete |
		position := position + incomplete count.
		incomplete pass].
	position := position + anInteger.
	^anInteger! !

!XTPositionWriteSubstream methodsFor: 'testing' stamp: 'MartinKobetic 12/31/2010 00:56'!
isPositionable
	^destination isPositionable! !

!XTPositionWriteSubstream methodsFor: 'seeking' stamp: 'nice 10/10/2010 18:14'!
length
	^destination available + position! !

!XTPositionWriteSubstream methodsFor: 'initialize-release' stamp: 'nice 10/10/2010 18:14'!
on: aDestination
	super on: aDestination.
	position := 0! !

!XTPositionWriteSubstream methodsFor: 'seeking' stamp: 'nice 10/10/2010 18:15'!
position
	^position! !

!XTPositionWriteSubstream methodsFor: 'seeking' stamp: 'MartinKobetic 1/11/2011 17:53'!
position: anInteger
	| available adjustment |
	self isPositionable ifFalse: [self error: 'This stream is not positionable.'].

	anInteger < 0 ifTrue: [Incomplete zero raise].
	available := anInteger min: self length.
	adjustment := available - position.
	adjustment positive
		ifTrue: [ destination ++ adjustment ]
		ifFalse: [ destination -- adjustment negated ].
	position := available.
	available = anInteger ifTrue: [^anInteger].
	(Incomplete count: available) raise! !

!XTPositionWriteSubstream methodsFor: 'accessing' stamp: 'nice 10/10/2010 18:13'!
put: anObject
	| object |
	object := destination put: anObject.
	position := position + 1.
	^object! !

!XTPositionWriteSubstream methodsFor: 'accessing' stamp: 'MartinKobetic 1/11/2011 17:53'!
write: anInteger from: aSequenceableCollection at: startIndex
	[destination write: anInteger from: aSequenceableCollection at: startIndex] on: Incomplete do: [:incomplete |
		position := position + incomplete count.
		incomplete pass].
	position := position + anInteger.
	^anInteger! !

XTWriteSubstream subclass: #XTTestWriteSubstream
	instanceVariableNames: 'substreamAtEnd test inclusive'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-Substreams'!

!XTTestWriteSubstream commentStamp: '<historical>' prior: 0!
This is a substream bounded by an element matching the @test criteria.

Instance Variables
	substreamAtEnd	<Boolean> is this substream at end
	test	<BlockClosure> the bounding criteria
	inclusive	<Boolean> is the boundary part of the substream contents

!

!XTTestWriteSubstream class methodsFor: 'instance creation' stamp: 'nice 10/10/2010 18:04'!
on: aDestination test: testBlock inclusive: aBoolean
	^self new on: aDestination test: testBlock inclusive: aBoolean! !

!XTTestWriteSubstream methodsFor: 'accessing' stamp: 'nice 7/8/2011 23:19'!
insert: anInteger from: aSequenceableCollection at: startIndex
	^self write: anInteger from: aSequenceableCollection at: startIndex! !

!XTTestWriteSubstream methodsFor: 'testing' stamp: 'nice 10/10/2010 18:30'!
isPositionable
	^false! !

!XTTestWriteSubstream methodsFor: 'initialize-release' stamp: 'nice 10/10/2010 18:31'!
on: aDestination test: testBlock inclusive: aBoolean
	self on: aDestination.
	test := testBlock.
	inclusive := aBoolean.
	substreamAtEnd := false! !

!XTTestWriteSubstream methodsFor: 'accessing' stamp: 'MartinKobetic 1/11/2011 17:53'!
put: anObject
	substreamAtEnd ifTrue: [Incomplete zero raise].
	((substreamAtEnd := test value: anObject) and: [inclusive not]) ifTrue: [Incomplete zero raise].
	[destination put: anObject] on: Incomplete do: [:incomplete | destinationAtEnd := substreamAtEnd := true. incomplete pass].
	^anObject! !

!XTTestWriteSubstream methodsFor: 'private' stamp: 'nice 10/10/2010 18:31'!
streamingInsert: anInteger from: aReadStream
	self streamingWrite: anInteger from: aReadStream! !

!XTTestWriteSubstream methodsFor: 'private' stamp: 'nice 10/10/2010 18:31'!
streamingInsertFrom: aReadStream
	self streamingWriteFrom: aReadStream! !

!XTTestWriteSubstream methodsFor: 'private' stamp: 'MartinKobetic 1/11/2011 17:53'!
streamingWrite: anInteger from: aReadStream
	| count object |
	substreamAtEnd ifTrue: [Incomplete zero raise].
	count := 0.
	[[count < anInteger and: [substreamAtEnd not]] whileTrue:
		[object := aReadStream get.
		((substreamAtEnd := test value: object) and: [inclusive not]) ifFalse: [destination put: object].
		count := count + 1]]
			on: Incomplete do: [:incomplete |
				destinationAtEnd := substreamAtEnd := true.
				(Incomplete count: count) raise].
	count < anInteger ifTrue: [(Incomplete count: count) raise].
	^anInteger! !

!XTTestWriteSubstream methodsFor: 'private' stamp: 'MartinKobetic 1/11/2011 17:53'!
streamingWriteFrom: aReadStream
	| object count |
	substreamAtEnd ifTrue: [Incomplete zero raise].
	count := 0.
	^[[substreamAtEnd not] whileTrue:
		[object := aReadStream get.
		((substreamAtEnd := test value: object) and: [inclusive not]) ifFalse: [destination put: object. count := count + 1]].
		count
	] on: Incomplete do: [:incomplete | destinationAtEnd := substreamAtEnd := true. count ]! !

!XTTestWriteSubstream methodsFor: 'accessing' stamp: 'MartinKobetic 1/11/2011 17:53'!
write: anInteger from: aSequenceableCollection at: startIndex
	| count object |
	substreamAtEnd ifTrue: [Incomplete zero raise].
	count := 0.
	[[count < anInteger and: [substreamAtEnd not]] whileTrue:
		[object := aSequenceableCollection at: startIndex + count.
		((substreamAtEnd := test value: object) and: [inclusive not]) ifFalse: [destination put: object].
		count := count + 1]]
			on: Incomplete do: [:incomplete |
				destinationAtEnd := substreamAtEnd := true.
				(Incomplete on: aSequenceableCollection count: count at: startIndex) raise].
	count < anInteger ifTrue: [(Incomplete on: aSequenceableCollection count: count at: startIndex) raise].
	^anInteger! !

!XTWriteSubstream class methodsFor: 'private' stamp: 'MartinKobetic 1/11/2011 17:53'!
slice: sliceBlock close: closeBlock
	| substream |
	substream := nil.
	^[substream == nil ifFalse:
		[substream substreamClosed ifFalse: [substream close].
		substream subseekend.
		substream destinationAtEnd ifTrue: [Incomplete zero raise]].
	substream := sliceBlock value]
		reading
			closeBlock: closeBlock;
			yourself! !

!XTWriteSubstream methodsFor: 'initialize-release' stamp: 'nice 10/13/2010 20:04'!
close
	closeBlock cull: self.
	substreamClosed := true! !

!XTWriteSubstream methodsFor: 'accessing' stamp: 'nice 10/10/2010 18:26'!
closeBlock
	^closeBlock! !

!XTWriteSubstream methodsFor: 'accessing' stamp: 'nice 10/10/2010 18:27'!
closeBlock: anObject
	closeBlock := anObject! !

!XTWriteSubstream methodsFor: 'initialize-release' stamp: 'nice 10/10/2010 18:27'!
contentsSpecies
	^destination contentsSpecies! !

!XTWriteSubstream methodsFor: 'testing' stamp: 'nice 10/10/2010 18:28'!
destinationAtEnd
	^destinationAtEnd! !

!XTWriteSubstream methodsFor: 'accessing' stamp: 'nice 7/8/2011 23:19'!
insert: anInteger from: aSequenceableCollection at: startIndex
	[destination insert: anInteger from: aSequenceableCollection at: startIndex] on: Incomplete do: [:incomplete |
		destinationAtEnd := true.
		incomplete pass].
	^anInteger! !

!XTWriteSubstream methodsFor: 'initialize-release' stamp: 'nice 10/10/2010 18:27'!
on: aDestination
	super on: aDestination.
	closeBlock := [].
	destinationAtEnd := false.
	substreamClosed := false! !

!XTWriteSubstream methodsFor: 'accessing' stamp: 'MartinKobetic 1/11/2011 17:53'!
put: anObject
	[destination put: anObject] on: Incomplete do: [:incomplete |
		destinationAtEnd := true.
		incomplete pass]! !

!XTWriteSubstream methodsFor: 'initialize-release' stamp: 'nice 10/10/2010 18:27'!
subseekend! !

!XTWriteSubstream methodsFor: 'testing' stamp: 'nice 10/10/2010 18:28'!
substreamClosed
	^substreamClosed! !

!XTWriteSubstream methodsFor: 'accessing' stamp: 'MartinKobetic 1/11/2011 17:53'!
write: anInteger from: aSequenceableCollection at: startIndex
	[destination write: anInteger from: aSequenceableCollection at: startIndex] on: Incomplete do: [:incomplete |
		destinationAtEnd := true.
		incomplete pass].
	^anInteger! !

!SequenceableCollection methodsFor: '*Xtreams-Substreams-private' stamp: 'nice 10/15/2010 22:19'!
streamingMatchPrefixFunction
	"Compute the array that tells us how far we need to back up when a match fails. This is using the Knuth-Morris-Pratt matching algorithm"

	| backtrack partialMatch |
	backtrack := Array new: self size + 1. 
	backtrack at: 1 put: 1; at: 2 put: 1.
	partialMatch := 1.

	2 to: self size do: [:index |
		| current |
		current := self at: index.

		"If there's a mismatch, back up to the previous partial match and see if the match can continue from there. If not, repeat until we find a match or hit the beginning"
		[partialMatch > 1 and: [(self at: partialMatch) ~= current]]
			whileTrue: [partialMatch := backtrack at: partialMatch - 1].

		(self at: partialMatch) = current
			ifTrue: [partialMatch := partialMatch + 1].
		backtrack at: index put: partialMatch].

	^backtrack! !

!SequenceableCollection methodsFor: '*Xtreams-Substreams-private' stamp: 'MartinKobetic 12/31/2010 14:11'!
streamingReadMatching: aStream inclusive: tail
	"Return a stream that produces substreams that separate by @pattern and include the pattern in the result if @tail is true.
	 It uses the Knuth-Morris-Pratt algorithm, from Cormen et al.'s Algorithms, page 871. See also Gusfield's Alorithms on Strings, Trees and Sequences, page 23. This algorithm has the advantage in stream matching that it reads every character in the the text to be matched against exactly once, and never backtracks."

	| backtrack |
	backtrack := self streamingMatchPrefixFunction.
	^XTMatchReadSubstream on: aStream pattern: self backtrack: backtrack inclusive: tail! !

!SequenceableCollection methodsFor: '*Xtreams-Substreams-private' stamp: 'MartinKobetic 12/31/2010 14:09'!
streamingWriteMatching: aStream inclusive: tail
	"Return a stream that produces substreams that separate by @pattern and include the pattern in the result if @tail is true.
	 It uses the Knuth-Morris-Pratt algorithm, from Cormen et al.'s Algorithms, page 871. See also Gusfield's Alorithms on Strings, Trees and Sequences, page 23. This algorithm has the advantage in stream matching that it reads every character in the the text to be matched against exactly once, and never backtracks."

	| backtrack |
	backtrack := self streamingMatchPrefixFunction.
	^XTMatchWriteSubstream on: aStream pattern: self backtrack: backtrack inclusive: tail! !

!XTReadStream methodsFor: '*Xtreams-Substreams-substreaming' stamp: 'MartinKobetic 1/1/2011 12:05'!
, aReadStream
	"Return a read stream that combines self and @aReadStream into a single stream.
	""
		((1 to: 5) reading, (6 to: 10) reading) rest
	""
		| files |
		files := '/pub/vw7.8' asFilename reading.
		[ | fn | fn := files get. fn isDirectory ifTrue: [ files := fn reading, files ]. fn ] reading rest
	"
	^(Array with: self with: aReadStream) reading stitching! !

!XTReadStream methodsFor: '*Xtreams-Substreams-substreaming' stamp: 'MartinKobetic 12/31/2010 01:01'!
closing: aBlock
	^(XTPositionReadSubstream on: self)
		closeBlock: aBlock;
		yourself! !

!XTReadStream methodsFor: '*Xtreams-Substreams-substreaming' stamp: 'nice 10/10/2010 18:36'!
ending: aMatchable
	"Creates a substream that will end when aMatchable finds a match in the content passing through. aMatchable is either
		* a block that is evaluated with each element; the stream ends when the block returns true
		* a collection that is matched against the last elements read, the stream ends when the collection matches
		* any other object, the stream matches when an equal object is read from the stream"
	"	aMatchable	<BlockClosure | Collection | Object>
		^<TransformReadStream>
	""
		('abcdefghijklmnopqrstuvxyz' reading ending: $j) rest.
	""
		('abcdefghijklmnopqrstuvxyz' reading ending: 'mno') rest
	""
		('abcdefghijklmnopqrstuvxyz' reading ending: [ :e | 'gmt' includes: e ]) rest
	"
	^self ending: aMatchable inclusive: false! !

!XTReadStream methodsFor: '*Xtreams-Substreams-substreaming' stamp: 'nice 10/10/2010 18:36'!
ending: aMatchable inclusive: inclusive
	"Creates a substream that will end when aMatchable finds a match in the content passing through. aMatchable is either
		* a block that is evaluated with each element - the stream ends when the block returns true
		* a collection that is matched against the last elements read - the stream ends when the collection matches
		* any other object - the stream matches when an equal object is read from the stream
	The inclusive parameter determins if the elements matching the end condition should be included in the substream contents or not."
	"	aMatchable	<BlockClosure | Collection | Object>	the substream ending criteria
		inclusive	<Boolean> should the content matching the end condition be included in the substream
		^<TransformReadStream>
	""
		('abcdefghijklmnopqrstuvxyz' reading ending: $j inclusive: true) rest.
	""
		('abcdefghijklmnopqrstuvxyz' reading ending: 'mno' inclusive: true) rest
	""
		('abcdefghijklmnopqrstuvxyz' reading ending: [ :e | 'gmt' includes: e ] inclusive: true) rest
	"
	^aMatchable streamingReadMatching: self inclusive: inclusive! !

!XTReadStream methodsFor: '*Xtreams-Substreams-substreaming' stamp: 'MartinKobetic 1/1/2011 12:04'!
limiting: limit
	"Create a substream that will allow at most @limit number of elements to be read from the source."
	"	limit		<Integer>	maximum number of elements that can be read from the source
		^<LimitReadStream>"
	"
		('abcdefghi' reading limiting: 5) rest
	"
	^XTLimitReadSubstream on: self limit: limit! !

!XTReadStream methodsFor: '*Xtreams-Substreams-substreaming' stamp: 'MartinKobetic 1/11/2011 17:53'!
slicing
	"From a readable stream, return a readable stream that acts as a prototype factory for the readable stream."
	"	^<ReadStream>"
	"
		((1 to: 100) reading limiting: 10) slicing do: [:substream | Transcript cr; print: substream rest]
	"
	| substream |
	substream := nil.
	^[substream == nil ifFalse:
		[substream substreamClosed ifFalse: [substream close].
		substream subseekend.
		substream sourceAtEnd ifTrue: [Incomplete zero raise]].
	substream := self copy]
		reading
			closeBlock: [source close];
			yourself! !

!XTReadStream methodsFor: '*Xtreams-Substreams-substreaming' stamp: 'MartinKobetic 1/7/2011 09:43'!
stitching
	"From a stream that returns streams (either read or write streams), stitch them together sequencially such that they appear to be one contiguous stream."
	"^ <StitchReadStream>"
	"
		| data current |
		data := (1 to: 100) reading.
		current := nil.
		[	(current notNil and: [ current position < 10 ]) ifTrue: [ Incomplete zero raise ].
			current := data limiting: 10
		] reading stitching rest
	"
	| first |
	first := self get.
	first isReadable ifTrue: [^XTStitchReadStream on: self first: first].
	first isWritable ifTrue: [^XTStitchWriteStream on: self first: first].
	^self error: 'Cannot read or write to this stream, what is it?'! !

XTReadStream subclass: #XTReadSubstream
	instanceVariableNames: 'sourceAtEnd closeBlock substreamClosed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-Substreams'!

!XTReadSubstream commentStamp: '<historical>' prior: 0!
This is abstract superclass of all substreams. Substreams normally don't close their underlying source, their closing behavior is customized via closeBlock.

Instance Variables
	sourceAtEnd	<Boolean> flags end of the source
	closeBlock	<BlockClosure> unary block invoked in response to #close, allows customizing closing behavior
	substreamClosed	<Boolean> flags the end of the receiver

!

XTReadSubstream subclass: #XTMatchReadSubstream
	instanceVariableNames: 'substreamAtEnd pattern patternStart inclusive hasReread reread buffer backtrack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-Substreams'!

!XTMatchReadSubstream commentStamp: '<historical>' prior: 0!
This is a substream bounded by a string pattern. The algorithm used doesn't need to peek or step back to detect the pattern, so it can be used on non-positionable streams.

Instance Variables
	substreamAtEnd	<Boolean> is this substream at end
	pattern	<String> the bounding pattern
	patternStart	<Integer>
	inclusive	<Boolean> is the boundary part of the substream contents
	hasReread	<Boolean>
	reread	<Object>
	buffer	<RingBuffer> read-ahead buffer (to be able to stop before pattern if inclusive is false)
	backtrack	<Array> backtracking table for pattern

!

!XTMatchReadSubstream class methodsFor: 'instance creation' stamp: 'nice 10/10/2010 18:02'!
on: aSource pattern: aPattern backtrack: aBacktrack inclusive: aBoolean
	^self new on: aSource pattern: aPattern backtrack: aBacktrack inclusive: aBoolean! !

!XTMatchReadSubstream methodsFor: 'seeking' stamp: 'MartinKobetic 12/31/2010 00:43'!
-= anInteger
	^anInteger isZero
		ifTrue:	[self subseekend. 0]
		ifFalse:	[super -= anInteger]! !

!XTMatchReadSubstream methodsFor: 'initialize-release' stamp: 'MartinKobetic 12/31/2010 00:43'!
close
	super close.
	buffer recycle! !

!XTMatchReadSubstream methodsFor: 'accessing' stamp: 'MartinKobetic 1/11/2011 17:53'!
get
	buffer hasDataToRead ifTrue: [^buffer get].
	substreamAtEnd ifTrue: [Incomplete zero raise].

	self gobble.
	buffer hasDataToRead ifFalse: [Incomplete zero raise].
	^buffer get! !

!XTMatchReadSubstream methodsFor: 'private' stamp: 'MartinKobetic 1/11/2011 17:53'!
gobble
	| object match patternStop progress |
	patternStop := patternStart.
	[hasReread
		ifTrue: [hasReread := false. object := reread. reread := nil]
		ifFalse: [object := source get].
	[(match := object = (pattern at: patternStop)) ifTrue: [patternStop := patternStop + 1].
	match and: [patternStop <= pattern size]]
		whileTrue: [object := source get]]
			on: Incomplete do: [:incomplete |
				sourceAtEnd := substreamAtEnd := true].

	"A full pattern match"
	patternStop > pattern size ifTrue: [
		inclusive ifTrue: [buffer write: pattern size from: pattern at: 1].
		substreamAtEnd := true.
		^self].

	"No match at all, write out the object we just read"
	progress := patternStop - patternStart.
	(patternStart = 1 and: [progress = 0]) ifTrue: [
		sourceAtEnd ifFalse: [buffer put: object].
		patternStart := 1.
		^self].

	"Partial match, write out the part of the pattern previously matched and keep the object we just read to be re-read next time"
	hasReread := true.
	reread := object.
	buffer write: progress from: pattern at: patternStart.
	patternStart := backtrack at: patternStop! !

!XTMatchReadSubstream methodsFor: 'testing' stamp: 'nice 10/10/2010 18:21'!
isPositionable
	^false! !

!XTMatchReadSubstream methodsFor: 'initialize-release' stamp: 'nice 10/10/2010 18:20'!
on: aSource pattern: aPattern backtrack: aBacktrack inclusive: aBoolean
	self on: aSource.
	pattern := aPattern.
	buffer := XTRingBuffer new: pattern size class: self contentsSpecies.
	hasReread := false.
	backtrack := aBacktrack.
	patternStart := 1.
	inclusive := aBoolean.
	substreamAtEnd := false! !

!XTMatchReadSubstream methodsFor: 'accessing' stamp: 'MartinKobetic 1/11/2011 17:53'!
read: anInteger into: aSequenceableCollection at: startIndex
	| count amount |

	count := 0.
	[count < anInteger and: [buffer hasDataToRead or: [substreamAtEnd not]]] whileTrue:
		[buffer hasDataToRead ifFalse: [self gobble].
		buffer hasDataToRead ifFalse: [(Incomplete on: aSequenceableCollection count: count at: startIndex) raise].
		amount := buffer readSize min: (anInteger - count).
		buffer read: amount into: aSequenceableCollection at: startIndex + count.
		count := count + amount].
	count < anInteger ifTrue: [(Incomplete on: aSequenceableCollection count: count at: startIndex) raise].
	^anInteger! !

!XTMatchReadSubstream methodsFor: 'private' stamp: 'MartinKobetic 1/11/2011 17:53'!
streamingInsert: anInteger into: aWriteStream
	| count amount |

	count := 0.
	[count < anInteger and: [buffer hasDataToRead or: [substreamAtEnd not]]] whileTrue:
		[buffer hasDataToRead ifFalse: [self gobble].
		buffer hasDataToRead ifFalse: [(Incomplete count: count) raise].
		amount := buffer readSize min: (anInteger - count).
		aWriteStream insert: amount from: buffer.
		count := count + amount].
	count < anInteger ifTrue: [(Incomplete count: count) raise]! !

!XTMatchReadSubstream methodsFor: 'private' stamp: 'nice 10/10/2010 18:21'!
streamingInsertInto: aWriteStream
	| amount |

	[buffer hasDataToRead or: [substreamAtEnd not]] whileTrue:
		[buffer hasDataToRead ifFalse: [self gobble].
		amount := buffer readSize.
		aWriteStream insert: amount from: buffer]! !

!XTMatchReadSubstream methodsFor: 'private' stamp: 'MartinKobetic 1/11/2011 17:53'!
streamingWrite: anInteger into: aWriteStream
	| count amount |

	count := 0.
	[count < anInteger and: [buffer hasDataToRead or: [substreamAtEnd not]]] whileTrue:
		[buffer hasDataToRead ifFalse: [self gobble].
		buffer hasDataToRead ifFalse: [(Incomplete count: count) raise].
		amount := buffer readSize min: (anInteger - count).
		aWriteStream write: amount from: buffer.
		count := count + amount].
	count < anInteger ifTrue: [(Incomplete count: count) raise].
	^anInteger! !

!XTMatchReadSubstream methodsFor: 'private' stamp: 'MartinKobetic 12/31/2010 00:44'!
streamingWriteInto: aWriteStream
	| amount count |
	count := 0.
	[buffer hasDataToRead or: [substreamAtEnd not]] whileTrue:
		[buffer hasDataToRead ifFalse: [self gobble].
		amount := buffer readSize.
		aWriteStream write: amount from: buffer.
		count := count + amount ].
	^count! !

!XTMatchReadSubstream methodsFor: 'initialize-release' stamp: 'nice 10/10/2010 18:20'!
subseekend
	[buffer hasDataToRead or: [substreamAtEnd not]] whileTrue:
		[buffer hasDataToRead ifFalse: [self gobble].
		buffer readSkip: buffer readSize]! !

XTReadSubstream subclass: #XTPositionReadSubstream
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-Substreams'!

!XTPositionReadSubstream commentStamp: '<historical>' prior: 0!
This is an abstract substreams that keeps track of its own position and allows positioning if the underlying stream is positionable.

Instance Variables
	position	<Integer> current position within the substream

!

XTPositionReadSubstream subclass: #XTLimitReadSubstream
	instanceVariableNames: 'limit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-Substreams'!

!XTLimitReadSubstream commentStamp: 'nice 10/10/2010 20:33' prior: 0!
Limits the number of elements that can be read from the source stream.

Instance Variables
	limit	<Integer> maximum number of elements that can be read from this stream
	position	<Integer> number of elements already read from the stream

!

!XTLimitReadSubstream class methodsFor: 'instance creation' stamp: 'nice 10/10/2010 18:01'!
on: aSource limit: anInteger
	^self new on: aSource limit: anInteger! !

!XTLimitReadSubstream methodsFor: 'seeking' stamp: 'MartinKobetic 1/11/2011 17:53'!
-= anInteger
	| available |
	anInteger < 0 ifTrue: [Incomplete zero raise].
	available := anInteger min: limit.
	source ++ (limit - position - available).
	position := limit - available.
	available = anInteger ifTrue: [^anInteger].
	^(Incomplete count: available) raise! !

!XTLimitReadSubstream methodsFor: 'accessing' stamp: 'MartinKobetic 1/11/2011 17:53'!
get
	position = limit ifTrue: [Incomplete zero raise].
	^super get! !

!XTLimitReadSubstream methodsFor: 'seeking' stamp: 'nice 10/10/2010 18:12'!
length
	^limit! !

!XTLimitReadSubstream methodsFor: 'initialize-release' stamp: 'nice 10/10/2010 18:11'!
on: aSource limit: anInteger
	self on: aSource.
	limit := anInteger! !

!XTLimitReadSubstream methodsFor: 'accessing' stamp: 'MartinKobetic 1/11/2011 17:53'!
read: anInteger into: aSequenceableCollection at: startIndex
	| count |
	count := anInteger min: self available.
	super read: count into: aSequenceableCollection at: startIndex.
	count < anInteger ifTrue: [(Incomplete on: aSequenceableCollection count: count at: startIndex) raise].
	^anInteger! !

!XTLimitReadSubstream methodsFor: 'initialize-release' stamp: 'nice 10/10/2010 18:11'!
subseekend
	self isPositionable ifFalse: [^self].
	self -= 0! !

!XTPositionReadSubstream methodsFor: 'seeking' stamp: 'MartinKobetic 1/11/2011 17:53'!
++ anInteger
	| count |
	anInteger < 0 ifTrue: [ ^self -- anInteger negated ].
	count := self available min: anInteger.
	count := [source ++ count. count] on: Incomplete do: [ :ex | ex count ].
	position := position + count.
	count < anInteger ifTrue: [sourceAtEnd := true. (Incomplete count: count) raise].
	^anInteger! !

!XTPositionReadSubstream methodsFor: 'seeking' stamp: 'MartinKobetic 1/11/2011 17:53'!
-- anInteger
	| count |
	anInteger < 0 ifTrue: [ ^self ++ anInteger negated ].
	count := anInteger min: position.
	count := [source -- count. count] on: Incomplete do: [ :ex | ex count ].
	position := position - count.
	count < anInteger ifTrue: [(Incomplete count: count) raise].
	anInteger isZero ifFalse: [sourceAtEnd := false].
	^anInteger! !

!XTPositionReadSubstream methodsFor: 'seeking' stamp: 'MartinKobetic 1/7/2011 09:46'!
-= anInteger
	position := self length - anInteger max: 0.
	^source -= anInteger! !

!XTPositionReadSubstream methodsFor: 'accessing' stamp: 'nice 10/10/2010 18:09'!
get
	| object |
	object := super get.
	position := position + 1.
	^object! !

!XTPositionReadSubstream methodsFor: 'testing' stamp: 'nice 10/10/2010 18:09'!
isPositionable
	^source isPositionable! !

!XTPositionReadSubstream methodsFor: 'seeking' stamp: 'nice 10/10/2010 18:10'!
length
	^source available + position! !

!XTPositionReadSubstream methodsFor: 'initialize-release' stamp: 'nice 10/10/2010 18:09'!
on: aSource
	super on: aSource.
	position := 0! !

!XTPositionReadSubstream methodsFor: 'seeking' stamp: 'nice 10/10/2010 18:10'!
position
	^position! !

!XTPositionReadSubstream methodsFor: 'seeking' stamp: 'MartinKobetic 1/11/2011 17:53'!
position: anInteger
	| delta available |
	self isPositionable ifFalse: [self error: 'This stream is not positionable.'].

	anInteger < 0 ifTrue: [Incomplete zero raise].
	available := anInteger min: self length.
	delta := available - position.
	[delta positive
		ifTrue:	[source ++ delta]
		ifFalse:	[source -- delta negated]]
			on: Incomplete do: [sourceAtEnd := true].
	position := available.
	available = anInteger ifTrue: [^anInteger].
	(Incomplete count: available) raise! !

!XTPositionReadSubstream methodsFor: 'accessing' stamp: 'MartinKobetic 1/11/2011 17:53'!
read: anInteger into: aSequenceableCollection at: startIndex
	[source read: anInteger into: aSequenceableCollection at: startIndex] on: Incomplete do: [:incomplete |
		sourceAtEnd := true.
		position := position + incomplete count.
		incomplete pass].
	position := position + anInteger.
	^anInteger! !

!XTReadSubstream class methodsFor: 'private' stamp: 'MartinKobetic 1/11/2011 17:53'!
slice: sliceBlock close: closeBlock
	| substream |
	substream := nil.
	^[substream == nil ifFalse:
		[substream substreamClosed ifFalse: [substream close].
		substream subseekend.
		substream sourceAtEnd ifTrue: [Incomplete zero raise]].
	substream := sliceBlock value]
		reading
			closeBlock: closeBlock;
			yourself! !

!XTReadSubstream methodsFor: 'initialize-release' stamp: 'nice 10/13/2010 20:04'!
close
	closeBlock cull: self.
	substreamClosed := true! !

!XTReadSubstream methodsFor: 'accessing' stamp: 'nice 10/10/2010 18:25'!
closeBlock
	^closeBlock! !

!XTReadSubstream methodsFor: 'accessing' stamp: 'nice 10/10/2010 18:25'!
closeBlock: anObject
	closeBlock := anObject! !

!XTReadSubstream methodsFor: 'initialize-release' stamp: 'nice 10/10/2010 18:26'!
contentsSpecies
	^source contentsSpecies! !

!XTReadSubstream methodsFor: 'accessing' stamp: 'MartinKobetic 1/11/2011 17:53'!
get
	^[source get] on: Incomplete do: [:incomplete | sourceAtEnd := true. incomplete pass]! !

!XTReadSubstream methodsFor: 'initialize-release' stamp: 'nice 10/10/2010 18:26'!
on: aSource
	super on: aSource.
	closeBlock := [].
	sourceAtEnd := false.
	substreamClosed := false! !

!XTReadSubstream methodsFor: 'accessing' stamp: 'MartinKobetic 1/11/2011 17:53'!
read: anInteger into: aSequenceableCollection at: startIndex
	^[source read: anInteger into: aSequenceableCollection at: startIndex] on: Incomplete do: [:incomplete | sourceAtEnd := true. incomplete pass]! !

!XTReadSubstream methodsFor: 'testing' stamp: 'nice 10/10/2010 18:26'!
sourceAtEnd
	^sourceAtEnd! !

!XTReadSubstream methodsFor: 'initialize-release' stamp: 'nice 10/10/2010 18:26'!
subseekend! !

!XTReadSubstream methodsFor: 'testing' stamp: 'nice 10/10/2010 18:26'!
substreamClosed
	^substreamClosed! !

XTReadSubstream subclass: #XTTestReadSubstream
	instanceVariableNames: 'substreamAtEnd test inclusive'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-Substreams'!

!XTTestReadSubstream commentStamp: '<historical>' prior: 0!
This is a substream bounded by an element matching the @test criteria.

Instance Variables
	substreamAtEnd	<Boolean> is this substream at end
	test	<BlockClosure> the bounding criteria
	inclusive	<Boolean> is the boundary part of the substream contents

!

!XTTestReadSubstream class methodsFor: 'instance creation' stamp: 'nice 10/10/2010 18:04'!
on: aSource test: testBlock inclusive: aBoolean
	^self new on: aSource test: testBlock inclusive: aBoolean! !

!XTTestReadSubstream methodsFor: 'seeking' stamp: 'MartinKobetic 12/31/2010 01:04'!
-= anInteger
	^anInteger isZero
		ifTrue:	[self subseekend. 0]
		ifFalse:	[super -= anInteger]! !

!XTTestReadSubstream methodsFor: 'accessing' stamp: 'MartinKobetic 1/11/2011 17:53'!
get
	| object |
	substreamAtEnd ifTrue: [Incomplete zero raise].
	object := [source get] on: Incomplete do: [:incomplete | sourceAtEnd := substreamAtEnd := true. incomplete pass].
	(substreamAtEnd := test value: object) ifTrue:
		[inclusive ifTrue: [^object].
		Incomplete zero raise].
	^object! !

!XTTestReadSubstream methodsFor: 'testing' stamp: 'nice 10/10/2010 18:30'!
isPositionable
	^false! !

!XTTestReadSubstream methodsFor: 'initialize-release' stamp: 'nice 10/10/2010 18:29'!
on: aSource test: testBlock inclusive: aBoolean
	self on: aSource.
	test := testBlock.
	inclusive := aBoolean.
	substreamAtEnd := false! !

!XTTestReadSubstream methodsFor: 'accessing' stamp: 'MartinKobetic 1/11/2011 17:53'!
read: anInteger into: aSequenceableCollection at: startIndex
	| object count |

	substreamAtEnd ifTrue: [(Incomplete on: aSequenceableCollection count: 0 at: startIndex) raise].
	count := 0.
	[[count = anInteger or: [substreamAtEnd]] whileFalse:
		[object := source get.
		((substreamAtEnd := test value: object) not or: [inclusive]) ifTrue:
			[aSequenceableCollection at: startIndex + count put: object.
			count := count + 1]]]
				on: Incomplete do: [sourceAtEnd := substreamAtEnd := true. (Incomplete on: aSequenceableCollection count: count at: startIndex) raise].
	count < anInteger ifTrue: [(Incomplete on: aSequenceableCollection count: count at: startIndex) raise].
	^anInteger! !

!XTTestReadSubstream methodsFor: 'private' stamp: 'MartinKobetic 1/11/2011 17:53'!
streamingWrite: anInteger into: aWriteStream
	| object count |

	substreamAtEnd ifTrue: [Incomplete zero raise].
	count := 0.
	[[count = anInteger or: [substreamAtEnd]] whileFalse:
		[object := source get.
		((substreamAtEnd := test value: object) not or: [inclusive]) ifTrue:
			[aWriteStream put: object.
			count := count + 1]]]
				on: Incomplete do: [sourceAtEnd := substreamAtEnd := true. (Incomplete count: count) raise].
	count < anInteger ifTrue: [(Incomplete count: count) raise].
	^anInteger! !

!XTTestReadSubstream methodsFor: 'private' stamp: 'MartinKobetic 1/11/2011 17:53'!
streamingWriteInto: aWriteStream
	| object count |
	substreamAtEnd ifTrue: [^0].
	count := 0.
	^[	[	substreamAtEnd
		] whileFalse: [
			object := source get.
			(substreamAtEnd := test value: object)
				ifTrue:	[inclusive ifTrue: [aWriteStream put: object. count := count + 1]]
				ifFalse:	[aWriteStream put: object. count := count + 1]].
		count
	] on: Incomplete do: [sourceAtEnd := substreamAtEnd := true. count ]! !

!XTTestReadSubstream methodsFor: 'initialize-release' stamp: 'DaleHenrichs 03/11/2011 20:27'!
subseekend
	| object |
	substreamAtEnd ifTrue: [^self].
	[[substreamAtEnd] whileFalse:
		[object := source get.
		substreamAtEnd := test value: object]]
			on: Incomplete do: [:ex | sourceAtEnd := substreamAtEnd := true]! !

XTReadStream subclass: #XTStitchReadStream
	instanceVariableNames: 'active contentsSpecies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-Substreams'!

!XTStitchReadStream commentStamp: '<historical>' prior: 0!
StitchReadStream combines a stream of source which returns streams in to a single continuous stream.

Instance Variables
	active	<ReadStream>	the substream that is currently active
	contentsSpecies	<Class>	the contents species of the substreams

!

!XTStitchReadStream class methodsFor: 'instance creation' stamp: 'nice 7/8/2011 23:10'!
on: aSource contentsSpecies: aClass
	^self new on: aSource contentsSpecies: aClass! !

!XTStitchReadStream class methodsFor: 'instance creation' stamp: 'MartinKobetic 1/1/2011 16:40'!
on: aSource first: firstActiveStream
	^self new on: aSource first: firstActiveStream! !

!XTStitchReadStream methodsFor: 'initialize-release' stamp: 'MartinKobetic 1/1/2011 12:05'!
close
	active == nil ifFalse: [active close].
	super close! !

!XTStitchReadStream methodsFor: 'initialize-release' stamp: 'MartinKobetic 1/1/2011 12:05'!
contentsSpecies
	^contentsSpecies! !

!XTStitchReadStream methodsFor: 'initialize-release' stamp: 'nice 7/8/2011 23:13'!
on: aSource contentsSpecies: aClass
	super on: aSource.
	contentsSpecies := aClass! !

!XTStitchReadStream methodsFor: 'initialize-release' stamp: 'MartinKobetic 1/1/2011 12:05'!
on: aSource first: firstActiveStream
	super on: aSource.
	active := firstActiveStream.
	contentsSpecies := active contentsSpecies! !

!XTStitchReadStream methodsFor: 'accessing' stamp: 'MartinKobetic 1/11/2011 17:53'!
read: anInteger into: aSequenceableCollection at: startIndex
	| remaining amount index |
	index := startIndex.
	remaining := anInteger.
	amount := 0.
	[
		active == nil ifTrue: [
			[active := source get]
				on: Incomplete
				do: [:ex | (Incomplete on: aSequenceableCollection count: anInteger - remaining at: startIndex) raise]].
		amount := [active read: remaining into: aSequenceableCollection at: index] on: Incomplete do: [:ex | ex count].
		remaining := remaining - amount.
		index := index + amount.
		remaining > 0] whileTrue:
			[active close.
			active := nil].
	^anInteger! !
